﻿namespace UltraGridAddNewRow
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Override.AllowAddNew = AllowAddNew.TemplateOnBottom;
            this.ultraGrid1.SetDataBinding(this.GetData(), "table1");
            this.ultraGrid1.Rows.ExpandAll(true);
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            DataTable t2 = ds.Tables.Add("table2");
            t2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t2.Columns.Add("pid", typeof(int));
            t2.Columns.Add("Name", typeof(string));
            t2.Columns.Add("Address", typeof(string));
            t2.Columns.Add("Number", typeof(int));

            DataTable t3 = ds.Tables.Add("table3");
            t3.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t3.Columns.Add("pid", typeof(int));
            t3.Columns.Add("Name", typeof(string));
            t3.Columns.Add("Expired", typeof(bool));

            ds.Relations.Add(t1.Columns["id"], t2.Columns["pid"]);
            ds.Relations.Add(t2.Columns["id"], t3.Columns["pid"]);

            ds = this.AddData(ds);

            return ds;
        }

        private DataSet AddData(DataSet ds)
        {
            ds.Tables["table1"].Rows.Add(new object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });

            ds.Tables["table2"].Rows.Add(new object[] { null, 0, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 1, "Coca - Cola", " Somewhere", 2 });

            ds.Tables["table3"].Rows.Add(new object[] { null, 0, "Coffee Shop ", true });
            ds.Tables["table3"].Rows.Add(new object[] { null, 1, "Coffee Shop ", true });

            return ds;
        }

        private void checkBoxAddNewRowBand0_CheckedChanged(object sender, EventArgs e)
        {
            var checkBox = sender as CheckBox;
            if (checkBox == null)
            {
                return;
            }

            if (checkBox.Checked)
            {
                this.ultraGrid1.DisplayLayout.Bands[0].Override.AllowAddNew = AllowAddNew.Yes;
            }
            else
            {
                this.ultraGrid1.DisplayLayout.Bands[0].Override.AllowAddNew = AllowAddNew.Default;
            }
        }
    }
}
